首页 学无止境Java正文

(转载)Java父类异常与子类异常之间的捕获关系

By无邪 Java 2020-11-06 10:11:26 108 0

异常

java

今天看到这么一段代码,请问输出的内容是什么?

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
class Annoyance extends Exception {}

class Sneeze extends Annoyance {}

class Human {

   public static void main(String[] args) throws Exception {
       try {
           try {
               throw new Sneeze();
           } catch (Annoyance a) {
               System.out.println("Caught Annoyance");
               throw a;
           }
       } catch (Sneeze s) {
           System.out.println("Caught Sneeze");
           return;
       } finally {
           System.out.println("Hello World!");
       }
   }
}

先别给出答案,思考一下平时我们写代码的过程中,异常捕获的过程和顺序,比如有这么一段代码:

1
2
3
4
5
try {
   throw new FileNotFoundException();
} catch (IOException e) {

}

我们经常能看到这样的代码,也就是使用父类能够捕获子类的异常,当然所有的异常都是继承Exception的,那么为什么不用Exception替换所有具体的异常类呢?这个是要考虑到我们对代码中预期异常的掌握,也就是某些代码会产生什么样的异常,程序员应当心中有数,如果全都用Exception的引用来接收,大家都是稀里糊涂的,如何进行处理也会变得难以着手。但如果在Catch代码块中不打算做任何处理,仅捕获而已,那么这时使用Exception也没什么关系,但正是生产环境下,这样的情况应该不允许存在的,这个看JDK的源码就知道了,捕获异常以后一定要给出提示信息的。
以上的代码证明了,我们可以用父类的引用接受子类的异常对象,那么问题来了,最上面的代码执行结果是什么呢?答案是:

1
2
3
Caught Annoyance
Caught Sneeze
Hello World!

相信第一行和第三行大家都没什么疑问了,关键是第二行,应该出来吗?是不是子类捕获了父类的异常呢?

经过断点的加入,我们发现,尽管

catch ( Annoyance a )

这一句使用的是父类的引用,但实际上是子类的对象,这是Java中多态的经典表现。在

catch ( Sneeze s )

的时候当然可以捕获到自己抛出来的异常了。

为了证明,子类从本质上无法捕获父类的异常,我们继续做个试验:

1
2
3
4
5
6
7
8
try {
   throw new Annoyance();
} catch (Sneeze s) {
   System.out.println("Caught Sneeze");
   return;
} finally {
   System.out.println("Hello World!");
}

可以看到,抛出了父类的异常,使用子类catch,这时候可以通过编译,但运行时呢?

1
2
3
Hello World!
Exception in thread "main" com.xq.exceptions.Annoyance
at com.xq.exceptions.Human.main(ExceptionTest.java:14)

可以看到,出了问题了,也就是说,父类throw出来的异常,子类并没有捕获到,继续往下证明:

1
2
3
4
5
6
7
8
9
10
11
try {
   throw new Annoyance();
} catch (Sneeze s) {
   System.out.println("Caught Sneeze");
   return;
} catch (Exception e) {
   System.out.println("Caught Exception");
   return;
} finally {
   System.out.println("Hello World!");
}

既然子类捕获不了,那就使用Exception,可以看到结果如下:

1
2
Caught Exception
Hello World!

看到这样,大家肯定都明白了,不用多说了!


本文标题:(转载)Java父类异常与子类异常之间的捕获关系
本文链接:https://dingqidong.com/?id=149
作者授权:除特别说明外,本文由 By无邪 原创编译并授权 无邪-blog 刊载发布。
版权声明:本文使用「署名-相同方式共享 4.0 国际」创作共享协议,转载或使用请遵守署名协议。

评论

关于我们
个人博客
关注本站微信号,享受更多服务!
联系方式
电话:
地址:
Email:
邮编:
Copyright ©2019-2020.Powered by©本站隶属于黎明工作室 鲁ICP备19054880号-1

鲁公网安备 37098302000619号

本站已安全运行: